<?php
// BS Counter PHP (v2.5.3)
// Copyright 1999-2005 Brian Stanback <brian at stanback dot net>
// This software is protected under the GNU General Public License (see LICENSE)

//
// Set config options (see the docs/README for config instructions)
//

// Sites allowed to use the counter.
$allowed = array("stanback.net", "brianstanback.com");

// Directory where png digit images are located (include trailing slash)
$digits_dir = "../../bscounter-common/images/digits/";

// Directory that houses the xml data files (include trailing slash)
$data_dir = "../../bscounter-common/data/";

//
// Begin script
//

$time = date("z1y");
$total = 0;
$hosts = array();

$file = validate_input($_GET['page']);
if ($file == "") { $file = "default"; }
$style = validate_input($_GET['style']);
if ($style == "") { $style = "LED_g"; }
$nbdigits = validate_input($_GET['nbdigits']);
if ($nbdigits == "") { $nbdigits = 5; }
$allow_reloads = validate_input($_GET['reloads']);
if ($allow_reloads == "") { $allow_reloads = 0; }

$x = validate_input($_GET['x']);
$y = validate_input($_GET['y']);

$referer = validate_input($_GET['referer']);

//
// Check referer for proper access
//

$verified = 0;
if ($_SERVER['HTTP_REFERER']) {
	foreach ($allowed as $host) {
		if (eregi($host, $_SERVER['HTTP_REFERER'])) { $verified = 1; break; }
	}
	if ($verified == 0) { exit(0); }
}

//
// Call the hit record function and print out the count
//

record_hit($file, $allow_reloads);

for ($i=0; $i<($nbdigits - strlen($total)); $i++) {
	$zeros .= '0';
}
$total = $zeros . $total;

foreach (preg_split("//", $total, -1, PREG_SPLIT_NO_EMPTY) as $num) {
	$digit[] = imagecreatefrompng("$digits_dir$style/" . $num . ".png");
}
$digits = count($digit);

if (!$x or !$y) {
	$x = imagesx($digit[0]);
	$y = imagesy($digit[0]);
}

$image = ImageCreate($digits*$x,$y);

for ($i=0; $i<$digits; $i++) { imagecopyresized($image, $digit[$i], $i*$x, 0, 0, 0, $x, $y, $x, $y); }

for ($i=0; $i<$digits; $i++) { imagedestroy($digit[$i]); }

header("Content-type: image/png");
header("Cache-control: no-cache");
imagepng($image);
imagedestroy($image);

//
// Append hit information to log file
//

function record_hit($file, $allow_reloads) {
	global $data_dir, $time, $total, $allow_reloads, $hosts;
	$total = 0;

	// Resolve hostname if web server hasnt already (for country statistics)
	if (!$_SERVER['REMOTE_HOST']) {
		$_SERVER['REMOTE_HOST'] = gethostbyaddr($_SERVER['REMOTE_ADDR']);
	}

	// Parse the XML stats file for hit count
	if (file_exists("$data_dir$file.xml")) {
		parse_xml("$data_dir$file.xml");
	}

	// Count hits in interm log file while checking for reloads
	if (file_exists("$data_dir$file.log")) {
		$deny_update = count_interm("$data_dir$file.log", $allow_reloads);
	}

	if ($deny_update != 1 and $allow_reloads != 1) {
		foreach ($hosts as $host) {
			if ($host == $_SERVER['REMOTE_HOST']) { $deny_update = 1; break; }
		}
	}

	// Append hit to interm log file
	if ($deny_update != 1) {
		if (file_exists($data_dir)) {
			$fh = fopen("$data_dir$file.log", "a");
			if (flock($fh, LOCK_EX)) {
				fseek($fh, 0, SEEK_END);
				fwrite($fh, $time . "\t" . validate_input($_SERVER['HTTP_USER_AGENT']) . "\t" . $referer . "\t" . validate_input($_SERVER['REMOTE_HOST']) . "\n");
				flock($fh, LOCK_UN);
			}
			fclose($fh);
			$total++;
		} else {
			echo "Counter Error: Data directory not found\n";
		}
	}
}

//
// XML Parsing Routines
//

function parse_xml($file) {
	global $total, $hosts;
	$fh = fopen($file, "r");
	if (flock($fh, LOCK_SH)) {
		while (!feof($fh)) {
			$line = fgets($fh, 4096);
			if (preg_match("/<total>(\d+)<\/total>/", $line, $regs)) { $total = $regs[1]; }
			elseif (preg_match("/<host value=\"(.*)\" \/>/", $line, $regs)) { array_push($hosts, $regs[1]); }
		}
		flock($fh, LOCK_UN);
	}
	fclose($fh);
}

//
// Interm log processing
//

function count_interm($file, $allow_reloads) {
	global $total;
	$deny_update = 0;
	$fh = fopen($file, "r");
	if (flock($fh, LOCK_SH)) {
		while (!feof($fh)) {
			$line = fgets($fh, 4096);
			$total++;
			if ($allow_reloads != 1) {
				list($access_time, $user_agent, $referer, $host) = explode("\t", trim($line));
				if ($host == $_SERVER['REMOTE_HOST']) { $deny_update = 1; }
			}
		}
		flock($fh, LOCK_UN);
	}
	fclose($fh);
	$total--;
	return $deny_update;
}

//
// Remove all 'innapropriate' characters
//

function validate_input($in) {
	return preg_replace("#[^A-z0-9-_.+=%&/\?\: ]#", "", $in);
}
?>