<?php
// BS Counter (v2.5.3)
// Copyright 1999-2005 Brian Stanback <brian at stanback dot net>
// This software is protected under the GNU General Public License (see LICENSE)

//
// Set config options (see the docs/README for config instructions)
//

// Directory that houses the xml data files (include trailing slash)
$data_dir = "../../bscounter-common/data/";

// Stats page header html
$header = "../../bscounter-common/templates/header.html";

// Stats page footer html
$footer = "../../bscounter-common/templates/footer.html";

// WWW path to the image directory (include trailing slash)
$image_dir = "../../bscounter-common/images/";

//
// First check for redirect
//

if ($_GET['redirect']) {
	echo header("Location: " . $_GET['redirect']);
	exit(0);
}

//
// Begin script
//

$time = date("z1y");
$geographic = array();
$agents = array();
$platforms = array();
$spiders = array();
$terms = array();
$referrers = array();
$hosts = array();

$file = validate_input($_GET['page']);

// List of agents (Name => Regex)
$agents_match = array(
		"Mozilla Firefox 1.x => Firefox",
		"Internet Explorer 7 => MSIE 7",
		"Internet Explorer 6 => MSIE 6",
		"Internet Explorer 5 => MSIE 5",
		"Internet Explorer &le;4 => MSIE",
		"Safari => Safari",
		"Pocket Internet Explorer => Windows CE|Pocket Internet Explorer",
		"AvantGo => AvantGo",
		"Netscape 8 => Netscape/8|NS8",
		"Netscape 7 => Netscape/7",
		"Netscape 6 => Netscape6",
		"Opera 9 => Opera/9|Opera 9",
		"Opera 8 => Opera/8|Opera 8",
		"Opera 7 => Opera/7|Opera 7",
		"Konqueror => Konqueror",
		"Flock => Flock",
		"PlayStation Portable => PlayStation",
		"WebTV => WebTV",
		"Java => Java|Sun",
		"Opera &le;6 => Opera",
		"Download Agents => File|file|Fetch|fetch|Download|download|Wget|Get|get|Zilla",
		"Mozilla/Gecko => Gecko",
		"Netscape Navigator => Mozilla/[3-4]",
	);

// List of spiders/robots (Name => Regex)
$spiders_match = array(
		"Google => Google",
		"AltaVista => Scooter",
		"Overture => MMCrawler|WebCrawler",
		"Yahoo => Yahoo",
		"MSN => msnbot",
		"FAST => FAST",
		"Ask Jeeves/Teoma => Teoma",
		"Alexa => alexa|ia_archiver",
		"Infoseek => Infoseek|Ultraseek",
		"Lycos => Lycos",
		"Inktomi/HotBot => Slurp",
		"Gigablast => Gigabot",
		"Baidu => Baiduspider",
		"Entireweb => Speedy Spider",
	);

// List of Platforms
$platforms_match = array(
		"Windows XP => Windows NT 5.1|Windows XP",
		"Windows 2000 => Windows NT 5.0|Windows 2000",
		"Windows NT => Windows NT|WinNT",
		"Windows 9x/ME => Windows|Win98|Win95",
		"Mac OSX => Mac OS X",
		"Mac PowerPC => Mac|PPC",
		"Linux => Linux",
		"HP-UX => HP-UX",
		"SunOS => SunOS",
		"BeOS => BeOS",
		"BSD => BSD",
		"UNIX => UNIX",
		"IRIX => IRIX",
		"QNX => QNX",
		"OS/2 => OS/2",
		"WebTV => WebTV",
	);

// Descriptions for all the crazy top-level domains out there
$domains = array(
	"com" => "Int/Commercial",
	"org" => "Int/Organization",
	"net" => "Int/Network",
	"gov" => "US Government",
	"mil" => "US Military",
	"edu" => "US Educational",
	"int" => "International",
	"aero" => "Air-transport industry",
	"biz" => "Int/Business",
	"coop" => "Int/Cooperatives",
	"info" => "Int/Informative",
	"museum" => "Int/Museum",
	"pro" => "Int. Professional",
	"af" => "Afghanistan",
	"al" => "Albania",
	"dz" => "Algeria",
	"as" => "American Somoa",
	"ad" => "Andorra",
	"ao" => "Angola",
	"ai" => "Anguilla",
	"aq" => "Antarctica",
	"ag" => "Antigua and Barbuda",
	"ar" => "Argentina",
	"am" => "Armenia",
	"aw" => "Aruba",
	"ac" => "Ascension Island",
	"au" => "Australia",
	"at" => "Austria",
	"az" => "Azerbaijan",
	"bh" => "Bahrain",
	"bd" => "Bangladesh",
	"bb" => "Barbados",
	"by" => "Belarus",
	"be" => "Belgium",
	"bz" => "Belize",
	"bj" => "Benin",
	"bm" => "Bermuda",
	"bt" => "Bhutan",
	"bo" => "Bolivia",
	"ba" => "Bosnia and Herzegovina",
	"bw" => "Botswana",
	"bv" => "Bouvet Island",
	"br" => "Brazil",
	"io" => "British Indian Ocean Territory",
	"bn" => "Brunei",
	"bg" => "Bulgaria",
	"bf" => "Burkina Faso",
	"bi" => "Burundi",
	"kh" => "Cambodia",
	"cm" => "Cameroon",
	"ca" => "Canada",
	"cv" => "Cape Verde",
	"cf" => "Central African Republic",
	"td" => "Chad",
	"gg" => "Channel Islands - Guernsey",
	"je" => "Channel Islands - Jersey",
	"cl" => "Chile",
	"cn" => "China",
	"cx" => "Christmas Island",
	"cc" => "Cocos (Keeling) Islands",
	"co" => "Colombia",
	"km" => "Comoros",
	"cg" => "Congo",
	"ck" => "Cook Islands",
	"cr" => "Costa Rica",
	"ci" => "Coted Ivoire",
	"hr" => "Croatia",
	"cu" => "Cuba",
	"cy" => "Cyprus",
	"cz" => "Czech Republic",
	"dk" => "Denmark",
	"dj" => "Djibouti",
	"dm" => "Dominica",
	"do" => "Dominican Republic",
	"tp" => "East Timor",
	"ec" => "Ecuador",
	"eg" => "Egypt",
	"sv" => "El Salvador",
	"gq" => "Equatorial Guinea",
	"er" => "Eritrea",
	"ee" => "Estonia",
	"et" => "Ethiopia",
	"fk" => "Falklands Islands",
	"fo" => "Faroe Islands",
	"fj" => "Fiji",
	"fi" => "Finland",
	"fr" => "France",
	"gf" => "French Guiana",
	"pf" => "French Polynesia",
	"tf" => "French Southern Territories",
	"fx" => "French Metropolitan",
	"ga" => "Gabon",
	"ge" => "Georgia",
	"de" => "Germany",
	"gh" => "Ghana",
	"gi" => "Gibraltar",
	"gr" => "Greece",
	"gl" => "Greenland",
	"gd" => "Grenada",
	"gp" => "Guadeloupe",
	"gu" => "Guam",
	"gt" => "Guatemala",
	"gn" => "Guinea",
	"gy" => "Guyana",
	"ht" => "Haiti",
	"hm" => "Heardand McDonald Islands",
	"hn" => "Honduras",
	"hk" => "HongKong",
	"hu" => "Hungary",
	"is" => "Iceland",
	"in" => "India",
	"id" => "Indonesia",
	"ir" => "Iran",
	"iq" => "Iraq",
	"ie" => "Ireland",
	"il" => "Israel",
	"it" => "Italy",
	"jm" => "Jamaica",
	"jp" => "Japan",
	"jo" => "Jordan",
	"kz" => "Kazakhstan",
	"ke" => "Kenya",
	"ki" => "Kiribati",
	"kp" => "Peoples Republic of Democratic Korea",
	"kr" => "Republic of Korea",
	"kw" => "Kuwait",
	"kg" => "Kyrgyzstan",
	"la" => "Laos",
	"lv" => "Latvia",
	"lb" => "Lebanon",
	"ls" => "Lesotho",
	"lr" => "Liberia",
	"ly" => "Libyan Arab Jamahiriya",
	"li" => "Liechtenstein",
	"lt" => "Lithuania",
	"lu" => "Luxembourg",
	"mo" => "Macao",
	"mk" => "Macedonia",
	"mw" => "Malawi",
	"my" => "Malaysia",
	"ml" => "Mali",
	"mt" => "Malta",
	"mh" => "Marshall Islands",
	"mq" => "Martinique",
	"mr" => "Mauritania",
	"mu" => "Mauritius",
	"yt" => "Mayotte",
	"mx" => "Mexico",
	"fm" => "Micronesia",
	"md" => "Moldova",
	"mc" => "Monaco",
	"mn" => "Mongolia",
	"ms" => "Montserrat",
	"ma" => "Morocco",
	"mz" => "Mozambique",
	"mm" => "Myanmar",
	"na" => "Namibia",
	"nr" => "Nauru",
	"np" => "Nepal",
	"nl" => "Netherlands",
	"an" => "Netherlands Antilles",
	"nc" => "New Caledonia",
	"nz" => "New Zealand",
	"ni" => "Nicaragua",
	"ne" => "Niger",
	"ng" => "Nigeria",
	"nu" => "Niue",
	"nf" => "Norfolk Island",
	"mp" => "Northern Mariana Islands",
	"no" => "Norway",
	"om" => "Oman",
	"pk" => "Pakistan",
	"pw" => "Palau",
	"pa" => "Panama",
	"pq" => "Papua New Guinea",
	"py" => "Paraguay",
	"pe" => "Peru",
	"ph" => "Philippines",
	"pn" => "Pitcairn",
	"pl" => "Poland",
	"pt" => "Portugal",
	"pr" => "Puerto Rico",
	"qa" => "Qatar",
	"re" => "Reunion",
	"ro" => "Romania",
	"ru" => "Russia",
	"rw" => "Rwanda",
	"kn" => "Saint Kitts and Nevis",
	"lc" => "Saint Lucia",
	"vc" => "Saint Vincent and the Grenadines",
	"ws" => "Samoa",
	"sm" => "San Marino",
	"st" => "Sao Tomeand Prin cipe",
	"sa" => "Saudi Arabia",
	"sn" => "Senegal",
	"sc" => "Seychelles",
	"sl" => "Sierra Leone",
	"sg" => "Singapore",
	"sk" => "Slovakia",
	"si" => "Slovenia",
	"sb" => "Solomon Islands",
	"so" => "Somalia",
	"za" => "South Africa",
	"gs" => "South Georgia and the South Sandwich Islands",
	"es" => "Spain",
	"lk" => "Sri Lanka",
	"sh" => "St. Helena",
	"pm" => "St. Pierreand Miquelon",
	"sd" => "Sudan",
	"sr" => "Suriname",
	"sj" => "Svalbardand Jan Mayen Islands",
	"sz" => "Swaziland",
	"se" => "Sweden",
	"ch" => "Switzerland",
	"sy" => "Syria",
	"tw" => "Taiwan",
	"tj" => "Tajikistan",
	"tz" => "Tanzania",
	"th" => "Thailand",
	"bs" => "The Bahamas",
	"ky" => "The Cayman Islands",
	"to" => "Tonga",
	"tt" => "Trinidad and Tobago",
	"tn" => "Tunisia",
	"tk" => "Tokelau",
	"tr" => "Turkey",
	"tm" => "Turkmenistan",
	"tc" => "Turks and Caicos Islands",
	"tv" => "Tuvalu",
	"ug" => "Uganda",
	"ua" => "Ukraine",
	"ae" => "United Arab Emirates",
	"uk" => "United Kingdom",
	"us" => "United States",
	"um" => "United States Minor Outlying Islands",
	"uy" => "Urugauy",
	"uz" => "Uzbekistan",
	"vu" => "Vanuatu",
	"va" => "Vatican City State",
	"ve" => "Venezuela",
	"vn" => "Vietnam",
	"vg" => "Virgin Islands (British)",
	"vi" => "Virgin Islands (US)",
	"wf" => "Wallis and Futuna Islands",
	"eh" => "Western Sahara",
	"ye" => "Yemen",
	"yu" => "Yugoslavia",
	"zr" => "Zaire",
	"zm" => "Zambia",
	"zw" => "Zimbabwe",
	"ip" => "Int/IP Address"
);

// Print the header
if (file_exists($header)) {
	$fh = fopen($header, "r");
	while (!feof($fh)) {
		$line = fgets($fh, 4096);
		if ($file) {
			$line = str_replace("<!--page-->", "Counter Stats for <span class=\"g\">$file</span>", $line);
		} else {
			$line = str_replace("<!--page-->", "Counter Stats", $line);
		}
		print $line;
	}
	fclose($fh);
}

if ($file and (file_exists("$data_dir$file.xml") or file_exists("$data_dir$file.log"))) {
	// Parse the XML stats file
	if (file_exists("$data_dir$file.xml")) {
		parse_xml($data_dir, $file);
	}

	// Parse intermediate log file and update stats/xml data file
	if (filesize("$data_dir$file.log") > 0 and file_exists("$data_dir$file.log")) {
		parse_log($data_dir, $file);
	}

	// Grab the totals so we can generate percentages
	foreach ($agents as $agent => $hits) {
		$browsers_total += $hits;
	}
	foreach ($platforms as $platform => $hits) {
		$platforms_total += $hits;
	}
	foreach ($spiders as $spider => $hits) {
		$spiders_total += $hits;
	}
	foreach ($geographic as $tld => $hits) {
		if ($domains[$tld])
			$geographic_total += $hits;
	}
	foreach ($terms as $term => $hits) {
		$terms_total += $hits;
	}

	echo "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
	echo "<tr><td>Total Hits:</td><td>" . number_format($total) . "</td></tr>\n";
	echo "<tr><td>Hits Today:</td><td>" . number_format($today[1]) . "</td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><th colspan=\"2\">Browsers</th></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	arsort($agents);
	foreach ($agents as $agent => $hits) {
		echo "<tr><td>$agent</td><td>".mkbar($hits, $browsers_total, "red", 1)."</td></tr>\n";
	}
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><th colspan=\"2\">Platforms</th></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	arsort($platforms);
	foreach ($platforms as $os => $hits) {
		echo "<tr><td>$os</td><td>".mkbar($hits, $platforms_total, "blue", 1)."</td></tr>\n";
	}
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	if (count($spiders) > 0) {
		echo "<tr><th colspan=\"2\">Spiders &amp; Robots</th></tr>\n";
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		arsort($spiders);
		foreach ($spiders as $spider => $hits) {
			echo "<tr><td>$spider</td><td>".mkbar($hits, $spiders_total, "green", 1)."</td></tr>\n";
		}
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	}
	echo "<tr><th colspan=\"2\">Top Countries</th></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	$i = 0;
	arsort($geographic);
	foreach ($geographic as $tld => $hits) {
		if ($domains[$tld]) {
			if ($i == 20) { break; }
			echo "<tr><td>$domains[$tld]</td><td>".mkbar($hits, $geographic_total, "purple", 1)."</td></tr>\n";
			$i++;
		}
	}
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	if (count($terms) > 0) {
		$i = 0;
		echo "<tr><th colspan=\"2\">Top Search Words</th></tr>\n";
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		arsort($terms);
		foreach ($terms as $term => $hits) {
			if ($i == 20) { break; }
			echo "<tr><td>$term</td><td>".mkbar($hits, $terms_total, "orange", 2)."</td></tr>\n";
			$i++;
		}
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	}
	if (count($referrers) > 0) {
		$i = 0;
		echo "<tr><th colspan=\"2\">Top Referrers</th></tr>\n";
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		arsort($referrers);
		foreach ($referrers as $ref => $hits) {
			if ($i == 20) { break; }
			$trunc_ref = substr($ref, 0, 90);
			if ($trunc_ref != $ref) { $trunc_ref .= '...'; }
			echo "<tr><td colspan=\"2\"><a href=\"" . $PHP_SELF . "?redirect=$ref\">$trunc_ref ($hits)</a></td></tr>\n";
			$i++;
		}
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	}
	echo "<tr><th colspan=\"2\">Last 20 Accesses</th></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	foreach ($hosts as $host) {
		echo "<tr><td colspan=\"2\">$host</td></tr>\n";
	}
	echo "</table>\n";
} else {
	if (file_exists($data_dir) and !$file) {
		echo "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
		echo "<tr><th>Available Pages</th></tr>\n";
		echo "<tr><td>&nbsp;</td></tr>\n";
		$dh = opendir($data_dir);
		while (false !== ($file = readdir($dh))) {
			if (ereg("\.log$", $file)) {
				$file = ereg_replace("\.log$", "", $file);
				echo "<tr><td>&#183; <a href=\"" . $_SERVER['SCRIPT_URI'] . "?page=$file\">$file</a></td></tr>\n";
			}
		}
		closedir($dh);
		echo "</table>\n";
	} else {
		echo "Error: Cannot open the specified counter. This may be because you have not yet placed the counter on your webpage, once the counter receives the first hit, the stats will become available.";
	}
}

// Print the footer
if (file_exists($footer)) {
	echo implode(file($footer));
}

//
// XML Parsing Routines
//

function parse_xml($data_dir, $file) {
	global $referrers, $hosts, $terms, $spiders, $geographic, $agents, $platforms, $today, $total;
	$fh = fopen("$data_dir$file.xml", "r");
	if (flock($fh, LOCK_SH)) {
		while (!feof($fh)) {
			$line = fgets($fh, 4096);
			if (preg_match("/<ref url=\"(.*)\" hits=\"(\d+)\" \/>/", $line, $regs)) { $referrers[$regs[1]] = $regs[2]; }
			elseif (preg_match("/<host value=\"(.*)\" \/>/", $line, $regs)) { array_push($hosts, $regs[1]); }
			elseif (preg_match("/<term value=\"(.*)\" hits=\"(\d+)\" \/>/", $line, $regs)) { $terms[$regs[1]] = $regs[2]; }
			elseif (preg_match("/<spider name=\"(.*)\" hits=\"(\d+)\" \/>/", $line, $regs)) { $spiders[$regs[1]] = $regs[2]; }
			elseif (preg_match("/<country tld=\"(.*)\" hits=\"(\d+)\" \/>/", $line, $regs)) { $geographic[$regs[1]] = $regs[2]; }
			elseif (preg_match("/<agent name=\"(.*)\" hits=\"(\d+)\" \/>/", $line, $regs)) { $agents[$regs[1]] = $regs[2]; }
			elseif (preg_match("/<os name=\"(.*)\" hits=\"(\d+)\" \/>/", $line, $regs)) { $platforms[$regs[1]] = $regs[2]; }
			elseif (preg_match("/<today time=\"(\d+)\">(\d+)<\/today>/", $line, $regs)) { $today[0] = $regs[1]; $today[1] = $regs[2]; }
			elseif (preg_match("/<total>(\d+)<\/total>/", $line, $regs)) { $total = $regs[1]; }
		}
		flock($fh, LOCK_UN);
	}
	fclose($fh);
}

//
// Parse intermediate log file, update XML file, and clear log
//

function parse_log($data_dir, $file) {
	global $agents_match, $platforms_match, $spiders_match, $referrers, $hosts, $terms, $spiders, $geographic, $agents, $platforms, $today, $total, $time;
	if ($today[0] != $time) { $today[1] = 0; }
	$fh = fopen("$data_dir$file.log", "r");
	if (flock($fh, LOCK_SH)) {
		while (!feof($fh)) {
			$line = fgets($fh, 4096);
			list($access_time, $user_agent, $referer, $host) = explode("\t", trim($line));
			if ($user_agent) {
				$total++;

				if ($time == $access_time) { $today[1]++; }

				preg_match("#([^.]+)$#", $host, $regs);
				if (is_numeric($regs[1])) {
					$geographic['ip']++;
				} else {
					$geographic[strtolower($regs[1])]++;
				}

				foreach ($agents_match as $agent) {
					list($name, $regex) = explode(" => ", $agent);
					if (preg_match("#$regex#", $user_agent)) { $agents[$name]++; break; }
				}
				foreach ($platforms_match as $platform) {
					list($name, $regex) = explode(" => ", $platform);
					if (preg_match("#$regex#", $user_agent)) { $platforms[$name]++; break; }
				}
				foreach ($spiders_match as $spider) {
					list($name, $regex) = explode(" => ", $spider);
					if (preg_match("#$regex#", $user_agent)) { $spiders[$name]++; break; }
				}

				if ($referer and preg_match("/^(http|https|ftp):\/\/(([A-Z0-9][A-Z0-9_-]*)(\.[A-Z0-9][A-Z0-9_-]*)+)(:(\d+))?([^?]+)?(\?(.*))?/i", $referer, $regs)) {
					if ($regs[9]) {
						list($ref_terms, $referer) = get_terms($regs[9], $referer);
						if (count($ref_terms) > 0) {
							foreach ($ref_terms as $term) {
								if (strlen($term) > 1 and strlen($term) < 30) {
									$terms[$term]++;
								}
							}
						}
					}
					if ($referer != "")
						$referrers[$referer]++;
				}

				array_unshift($hosts, $host);
			}
		}
		flock($fh, LOCK_UN);
	}
	fclose($fh);

	$hosts = array_slice($hosts, 0, 20);

	$xml = '<?xml version="1.0"?>' . "\n";
	$xml .= "<counter>\n";
	$xml .= "\t<total>$total</total>\n";
	$xml .= "\t<today time=\"$time\">$today[1]</today>\n";
	$xml .= "\t<geographic>\n";
	foreach ($geographic as $tld => $hits) {
		$xml .= "\t\t<country tld=\"$tld\" hits=\"$hits\" />\n";
	}
	$xml .= "\t</geographic>\n";
	$xml .= "\t<agents>\n";
	foreach ($agents as $agent => $hits) {
		$xml .= "\t\t<agent name=\"$agent\" hits=\"$hits\" />\n";
	}
	$xml .= "\t</agents>\n";
	$xml .= "\t<platforms>\n";
	foreach ($platforms as $os => $hits) {
		$xml .= "\t\t<os name=\"$os\" hits=\"$hits\" />\n";
	}
	$xml .= "\t</platforms>\n";
	$xml .= "\t<spiders>\n";
	foreach ($spiders as $spider => $hits) {
		$xml .= "\t\t<spider name=\"$spider\" hits=\"$hits\" />\n";
	}
	$xml .= "\t</spiders>\n";
	$xml .= "\t<terms>\n";
	foreach ($terms as $term => $hits) {
		$xml .= "\t\t<term value=\"$term\" hits=\"$hits\" />\n";
	}
	$xml .= "\t</terms>\n";
	$xml .= "\t<referrers>\n";
	foreach ($referrers as $ref => $hits) {
		$xml .= "\t\t<ref url=\"$ref\" hits=\"$hits\" />\n";
	}
	$xml .= "\t</referrers>\n";
	$xml .= "\t<hosts>\n";
	foreach ($hosts as $host) {
		if ($host) {
			$xml .= "\t\t<host value=\"$host\" />\n";
		}
	}
	$xml .= "\t</hosts>\n";
	$xml .= "</counter>";

	// Update XML data file
	$fh = fopen("$data_dir$file.xml", "w");
	if (flock($fh, LOCK_EX)) {
		fwrite($fh, $xml);
		flock($fh, LOCK_UN);
	}
	fclose($fh);

	// Clear log file
	$fh = fopen("$data_dir$file.log", "w");
	if (flock($fh, LOCK_EX)) {
		fwrite($fh, "");
		flock($fh, LOCK_UN);
	}
	fclose($fh);
}

//
// Get search engine terms
//

function get_terms($string, $referer) {
	foreach (explode("&", $string) as $paramater) {
		list($key, $val) = explode("=", $paramater);
		if ($key and ereg("^(q|p|query)$", $key)) {
			$referer = str_replace($string, "$key=$val", $referer);
			return array(explode(' ', validate_input(strtolower(urldecode($val)))), $referer);
		}
	}
}

//
// Print the progress bar
//

function mkbar($hits, $total, $color, $type) {
	global $image_dir;
	$percent = round(($hits / $total) * 100, 1);
	$width = intval(4.5 * $percent) + 1;
	if ($type == 1) {
		if ($percent == 0) { $percent = "&lt;0.1"; }
		return "<img src=\"$image_dir$color-lcap.gif\" height=\"12\" width=\"6\" /><img src=\"$image_dir$color-bar.gif\" height=\"12\" width=\"$width\" /><img src=\"$image_dir$color-rcap.gif\" height=\"12\" width=\"6\" /> $percent%";
	} else {
		return "<img src=\"$image_dir$color-lcap.gif\" height=\"12\" width=\"6\" /><img src=\"$image_dir$color-bar.gif\" height=\"12\" width=\"$width\" /><img src=\"$image_dir$color-rcap.gif\" height=\"12\" width=\"6\" /> $hits";
	}
}

//
// Remove all 'innapropriate' characters
//

function validate_input($in) {
	return preg_replace("#[^A-z0-9-_.+=&/\?\: ]#", "", $in);
}
?>